<template>
  <v-card
    :height="height"
    width="380"
    class="rounded-circle mx-auto my-3"
  >
    <div>
      <img
        :src="source"
        width="70px"
        height="70px"
        class="mt-4"
      >
    </div>
    <v-card-title
      class="font-weight-bold align-center text--center py-1"
      :class="textColorTitle"
      style="font-size:1.75rem"
      v-html="cardTitle"
    />
    <v-card-text
      class="font-weight-bold pt-2"
      :class="textColor"
    >
      {{ cardText }}
    </v-card-text>
    <v-card-actions class="align-end">
      <v-row
        class="justify-center"
      >
        <v-btn
          rounded
          class="mb-4 font-weight-bold"
          :class="cardTextColorButton+' '+cardColorButton"
          :href="hrefButton"
          :width="buttonSize"
        >
          {{ cardTextButton }}
        </v-btn>

        <v-tooltip
          v-if="mustBeLoggedButtonTwo && !userId"
          bottom
        >
          <template v-slot:activator="{ on }">
            <div
              style="width:100%;"
              v-on="on"
            >
              <v-btn
                v-if="cardTextButtonTwo!==''"
                :disabled="mustBeLoggedButtonTwo && !userId ? true : false"
                rounded
                class="ma-0 font-weight-bold"
                :class="cardTextColorButtonTwo+' '+cardColorButtonTwo"
                :href="hrefButtonTwo"
                width="250px"
              >
                {{ cardTextButtonTwo }}
              </v-btn>
            </div>
          </template>
          <span>{{ mustBeLoggedButtonTextTwo }}</span>
        </v-tooltip>
        <v-btn
          v-else-if="cardTextButtonTwo!==''"
          rounded
          width="250px"
          class="ma-0 font-weight-bold"
          :class="cardTextColorButtonTwo+' '+cardColorButtonTwo"
          :href="hrefButtonTwo"
        >
          {{ cardTextButtonTwo }}
        </v-btn>
      </v-row>
    </v-card-actions>
  </v-card>
</template>

<script>
const ALLOWED_BUTTON_SIZE = ['normal', 'large'];
export default {
  props: {
    cardTitle: {
      type: String,
      default: ""
    },
    cardText: {
      type: String,
      default: ""
    },    
    backgroundColor: {
      type: String,
      default: ""
    },
    backgroundColorCardTitle: {
      type: String,
      default: ""
    },
    textColorTitle: {
      type: String,
      default:""
    },
    backgroundImage: {
      type: String,
      default: ""
    },    
    textColor: {
      type: String,
      default: "secondary--text"
    },
    source: {
      type: String,
      default: ""
    },  
    mustBeLoggedButton:{
      type: Boolean,
      default: false
    },
    mustBeLoggedButtonText:{
      type: String,
      default: null
    },
    cardTextButton: {
      type: String,
      default: ""
    },    
    cardTextColorButton: {
      type: String,
      default: "secondary--text"
    }, 
    cardColorButton: {
      type: String,
      default: "secondary"
    },
    hrefButton: {
      type: String,
      default: "#"
    },
    cardSizeButton: {
      type: String,
      default: 'normal'
    },
    mustBeLoggedButtonTwo:{
      type: Boolean,
      default: false
    },
    mustBeLoggedButtonTextTwo:{
      type: String,
      default: null
    },
    cardTextButtonTwo: {
      type: String,
      default: ""
    },    
    cardTextColorButtonTwo: {
      type: String,
      default: "secondary--text"
    }, 
    cardColorButtonTwo: {
      type: String,
      default: "secondary"
    }, 
    hrefButtonTwo: {
      type: String,
      default: "#"
    },
    height: {
      type: Number,
      default: 380
    },
    userId: {
      type: Number,
      default: null
    }
  },
  data() {
    return {
    }
  },
  computed: {
    buttonSize() {
      return ALLOWED_BUTTON_SIZE.includes(this.cardSizeButton) && this.cardSizeButton === 'large' ? '300px' : '250px';
    }
  },
  watch: {
    cardSizeButton: {
      handler(newValue) {
        if (!ALLOWED_BUTTON_SIZE.includes(newValue)) {
          throw new Error('The given value is not allowed!');
        }
      },
      immediate : true
    }
  },
//   computed:{
//     styleBackgroundImage(){
//       return "background-image:url('"+this.backgroundImage+"')";
//     }
//   },
};
</script>
<style lang="scss" scoped>
.v-card{
  background-position: top 1.2vh left 3.2vh;
  background-size: 60%;
 
}
</style>
